<template>
    <section>
        <h2>Your Wallet</h2>

        <div class="card bg-transparent" style="min-height: 4rem;">
            <div class="card-body">
                <h3 class="card-title">Remaining Balance</h3>

                <a href="#" class="">Need Help Depositing?</a>
                <span class="float-right h3"><span v-if="loading"><i class="fas fa-spinner fa-spin"></i></span><span v-else>Br {{ Number(remainingBalance).toFixed(2)}}</span></span>
            </div>
        </div>

        <hr>

        <!--<h4>Transactions</h4>

        <table class="table table-hover" style="width: 99%">
            <thead>
            <tr>
                <th scope="col">#</th>
                <th scope="col">Date</th>
                <th scope="col">Amount</th>
                <th scope="col">Status</th>
            </tr>
            </thead>
            <tbody>
            <tr>
                <th scope="row">1</th>
                <td>Aug 20, 2019</td>
                <td>Br 100.00</td>
                <td>Completed</td>
            </tr>
            <tr>
                <th scope="row">2</th>
                <td>Jun 20, 2019</td>
                <td>Br 956.00</td>
                <td>Canceled</td>
            </tr>
            <tr>
                <th scope="row">3</th>
                <td>Sept 20, 2019</td>
                <td>Br 100.00</td>
                <td>Pending</td>
            </tr>
            </tbody>
        </table>-->

    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                remainingBalance: 0,

                // Loading Flag
                loading: false,

                // Status Flags
                success: false,
                fail: false,
            }
        },
        methods: {
            loadRemainingBalance: function () {
                // show the loading
                this.loading = true;

                // Clear previous status flags
                this.success = false;
                this.fail = false;

                // Make a request to the API
                axios.get('/api/advertiser/remaining-balance')
                    .then(response => {
                        this.remainingBalance = response.data.balance;
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Content Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e =>{
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Advertiser - Wallet mounted.');

            // Load the remaining balance
            this.loadRemainingBalance();
        }
    }
</script>
